module.exports = {
	/**
 	 * Map a function to every item in an array
     * Note that $func gets the current item AND a completion callback as parameters.
     * map() will wait until the completion callback was called before calling the next iteratee.
 	 *
 	 * @param array The array to walk over
 	 * @param iteratee The function to call on every item.
 	 * @param callback The callback to call after finishing
  	 * @param index DO NOT PASS THIS PARAMETER. It's used internally to keep track of $array.
 	*/
	map: function(array, iteratee, callback, index) {
    	if (typeof index === typeof undefined) index = 0;
    	if (index < array.length) {
        	iteratee(array[index], function () {
           	 module.exports.map(array, iteratee, callback, ++index);
        	});
    	} else {
        	callback();
    	}
	}
};
